diff --git a/shared/js/weston.ruter.net/webforms2/webforms2_src.js b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
index f15d8ee..5a8b110 100644
--- a/shared/js/weston.ruter.net/webforms2/webforms2_src.js
+++ b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
@@ -1,10 +1,11 @@
 /*
  * Web Forms 2.0 Cross-browser Implementation <http://code.google.com/p/webforms2/>
- * Version: 0.6.1 (2010-09-10)
+ * Version: 0.7 (2011-03-01)
  * Copyright: 2007, Weston Ruter <http://weston.ruter.net/> 
  *    with additions by Zoltan Hawryluk <http://www.useragentman.com>
- * License: GNU General Public License, Free Software Foundation
- *          <http://creativecommons.org/licenses/GPL/2.0/>
+ * Licenses (as of Feb 6, 2011)
+ * - MIT License (http://www.opensource.org/licenses/mit-license.php)
+ * - GPL (http://creativecommons.org/licenses/GPL/2.0/)
  * 
  * The comments contained in this code are largely quotations from the 
  * WebForms 2.0 specification: <http://whatwg.org/specs/web-forms/current-work/>
@@ -15,6 +16,10 @@
  * version 0.5.4  - initial release by Weston Ruter
  * version 0.6    - refactored for use with HTML5Widgets by Zoltan Hawryluk (July 27th, 2010)
  * version 0.6.1  - updated to deal with WebKit's half-implemented WebForms 2 Implementation (Sept 10, 2010)
+ * version 0.7    - bug fixes with nested repetition models by Zoltan Hawryluk.
+ * version 0.7.1  - updated to dual MIT/GPL 2.0 license.
+ * version 1.0    - Updated to mimic CSS validation pseudo-classes, support for newer browsers
+ *                  native support (IE10, Firefox 4, Webkit, Opera 11.11)
  */
 
 if(!window.$wf2){
@@ -32,10 +37,14 @@ $wf2 = {
 	hasElementExtensions : (window.HTMLElement && HTMLElement.prototype),
 	hasGettersAndSetters : ($wf2.__defineGetter__ && $wf2.__defineSetter__),
 	
-	hasBadImplementation: navigator.userAgent.indexOf('WebKit'),
+	hasBadImplementation: navigator.userAgent.indexOf('WebKit') > 0,
+	
+	// WebKit less than 534 doesn't show validation UI - we need to check for this (from http://stackoverflow.com/questions/6030522/html5-form-validation-modernizr-safari)
+	hasNativeBubbles: navigator.userAgent.indexOf('WebKit') < 0 || parseInt(navigator.userAgent.match(/AppleWebKit\/([^ ]*)/)[1].split('.')[0])  > 534,
 	
 	callBeforeValidation : new Array(),
 	callAfterValidation : new Array(),
+	callAfterDOMContentLoaded: new Array(),
 	
 	
 	onDOMContentLoaded : function(){
@@ -99,15 +108,16 @@ $wf2 = {
 		//   first, looking for templates so that their initial repetition blocks can be created. ... UAs should not 
 		//   specifically wait for images and style sheets to be loaded before creating initial repetition blocks 
 		//   as described above.
-		$wf2.initRepetitionBlocks();
-		$wf2.initRepetitionTemplates();
-		$wf2.initRepetitionButtons('add');
-		$wf2.initRepetitionButtons('remove');
-		$wf2.initRepetitionButtons('move-up');
-		$wf2.initRepetitionButtons('move-down');
-		$wf2.updateAddButtons();
-		$wf2.updateMoveButtons();
-	
+		if (window.$wf2Rep) {
+			$wf2.initRepetitionBlocks();
+			$wf2.initRepetitionTemplates();
+			$wf2.initRepetitionButtons('add');
+			$wf2.initRepetitionButtons('remove');
+			$wf2.initRepetitionButtons('move-up');
+			$wf2.initRepetitionButtons('move-down');
+			$wf2.updateAddButtons();
+			$wf2.updateMoveButtons();
+		}
 		// Initialize Non-Repetition Behaviors ****************************************
 		if(document.addEventListener){
 			document.addEventListener('mousedown', $wf2.clearInvalidIndicators, false);
@@ -119,8 +129,16 @@ $wf2 = {
 		}
 		
 		$wf2.initNonRepetitionFunctionality();
+		
+		for (var i=0; i<$wf2.callAfterDOMContentLoaded.length; i++) {
+			$wf2.callAfterDOMContentLoaded[i]();
+		}
 	},
 
+	
+	
+
+
 
 	/*##############################################################################################
 	 # Section: Fetching data from external resources
